#include <assert.h>
#include <stdio.h>
#include <string.h>
#include <vector>
#define MAX_LEN 100001
#define LETTER_MAX 62
using namespace std;

char text[MAX_LEN], result[MAX_LEN];
int text_len, result_len;

const int char2letter['z'-'0'+1] ={0,1,2,3,4,5,6,7,8,9,-1,-1,-1,-1,-1,-1,-1,10,11,12,13,
  14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,-1,-1,-1,-1,-1,-1,
  36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61};
#define CHAR2LETTER(c) char2letter[(c)-'0']

struct node {
  int back, out, next[LETTER_MAX];
} nodes[MAX_LEN];

int q[MAX_LEN], qs, qe;

int main(void) {
  assert(scanf("%s%n ", text, &text_len) > 0);

  for (int n = 0; scanf("%s%n ", result, &result_len) > 0;) {
    for (int i = 0, s = 0; i < result_len; i++) {
      int letter = CHAR2LETTER(result[i]);
      if (nodes[s].next[letter]) s = nodes[s].next[letter];
      else s = nodes[s].next[letter] = ++n;
    }
    nodes[n].out = result_len;
    assert(n < MAX_LEN);
  }
  assert(feof(stdin));

  nodes[0].back = -1;
  q[qe++] = 0;
  while (qs < qe) {
    struct node* node = nodes + q[qs++];
    for (int l = 0, next; l < LETTER_MAX; l++) if ((next = node->next[l])) {
      int back = node->back;
      while (back >= 0 && !nodes[back].next[l]) back = nodes[back].back;
      back = back >= 0 ? nodes[back].next[l] : 0;
      nodes[next].back = back;
      if (nodes[back].out) nodes[next].out = nodes[back].out;

      q[qe++] = next;
    }
    if (node->back == -1) continue;
    for (int l = 0, *back_next = nodes[node->back].next; l < LETTER_MAX; l++)
      if (!node->next[l]) node->next[l] = back_next[l];
  }

  q[result_len=0] = 0;
  for (int i = 0; i < text_len; i++) {
    int l = CHAR2LETTER(text[i]);
    int s = q[result_len];
    s = nodes[s].next[l];

    result[result_len++] = text[i];
    q[result_len] = s;
    if (nodes[s].out) result_len -= nodes[s].out;
  }

  result[result_len] = '\0';
  puts(result);

  return 0;
}
